program naturalValuation;
uses csvfilereader,vectorlib;
(*!
\section{Purpose}
The programme  computes labour values and all alternative value bases 
from input output tables. 

It outputs the  valuations using all bases other than labour
 then the 
vector of labour values and then the  vector of output at market value.
Output is in one vector per line space separated.

 
\section{Comand line interface}
{\bf Usage :} {\tt naturalValuation \em iotable.csv }


The files should be laid out with a first line and first column made up of text fields labeling
the rows and columns. All other cells should be numeric.
Discussion of matrix sizes in what follows refers exclusively to the rectangular subarray of
numeric values.
\subsection{iotable}
The first file, the iotable one, should contain an N by M io table in standard column form,
with a column corresponding to an industry so that cell at row i col j contains the amount
of output from the ith industry used by the jth industry.

The last line must contain the outputs of each industry.



 *)
 type pmat=^matrix;
      channel= record
		p:pcsv;
		r,c:pheadervec;
		m:^matrix;
	  end;
procedure rf(var ch:channel;param:integer );
(*! Read in one of the file parameters and extract the data from it *)
begin
    with ch do 
    begin
		p:=parsecsvfile(paramstr(param));
		if p=nil then 
		begin
		   writeln('error opening or parsing file ',paramstr(param));
		   halt(2);
		end
		else ;
		r:=getrowheaders(p);
		c:=getcolheaders(p);
		m:=getdatamatrix(p);
	end;
end;
var iot:channel; 
      L,V,O,O1,baseN:^vector;
      square:^matrix; 
      ip,normip, normo,normn:real;
    i,n,j:integer;
    function valuationN(n:integer):pvec;
    var i:integer;
    (*! compute the normalised value vector for the nth value base
    whilst doing this labour input assumed zero *)
    begin
        L^:=1;
	    for i:= 1 to 20 do
		begin
			L^[n]:=1;
			o1^:=  \+ (L^ * square ^);
			L^:= O1^/O^;
		end;
		valuationN:=(o1);
	end;
	
begin
	rf(iot,1);
	
	new(L,iot.m^.cols);new(V,iot.m^.cols);new(O,iot.m^.cols);new(O1,iot.m^.cols);
	L^:=1;
	V^:=iot.m^ [iot.m^.rows-1];
	O^:=iot.m^ [iot.m^.rows];
	normo:=sqrt(O^ . O^);
	new(square,iot.m^.cols,iot.m^.cols);
	square^ := trans iot.m^;
	for n:=1 to square . rows do 
	begin
		baseN:= valuationN(n);
		normn:= sqrt( baseN ^ . baseN ^);
		ip:=(O^.baseN^);
		write( ip/(normo*normo):12:3);
		
		write( ip/(normo*normn):12:3);
		write(baseN^:12:3);
		
	end;
	for i:= 1 to 20 do
	begin
		o1^:= V^+ \+ (L^ * square ^);
		L^:= O1^/O^;
	end;
	basen^:=o1^;
	normn:= sqrt( baseN ^ .basen ^);
		ip:=(O^.baseN^);
		{ scaled inner product}
		write( ip/(normo*normo):12:3);
		{normalised inner product}
		write( ip/(normo*normn):12:3);
	 
	
	writeln(O1^:12:3,1.0:12:3,1.0:12:3,O^:12:3);
	
end.

