program validate;
uses kantor,csvfilereader;
(*! Tests the kantor library using Kantorovich's original example .*)
const ctechniques : array[1..9,dest..src,0..5] of real =
       (((105,0,0,0,0,0),(0,0,0, -1,0,0)),
		( (107,0,0,0,0,0),(0,0,0, 0,-1,0)),
		((64,0,0,0,0,0),(0,0,0, 0,0,-1)),
		((0,56,0,0,0,0),(0,0,0, -1,0,0)),
		((0,66,0,0,0,0),(0,0,0, 0,-1,0)),
		((0,38,0,0,0,0),(0,0,0,  0,0,-1)),
		((0,0,56,0,0,0),(0,0,0, -1,0,0)),
		((0,0,83, 0,0,0),(0,0,0,0,-1,0)),
		((0,0,53, 0,0,0),(0,0,0, 0,0,-1)));
		
const     ctarget : array[0..5] of real=(20000,20000,20000,0,0,0) ;
          cstartingresource : array[0..5] of real =(0,0,0,1,1,1);
kantorovichsanswer:array[1..9]of real=
(
    0.671365     ,      0     ,      0,
    0.328635    ,0.789238     ,      0,
           0,    0.210762 ,          1);
procedure main;
var techniques:^technologytable; var target,startingresource,L,R:^ODVvec; var X:^intensityvec;
    csvtree:pcsv;
    dump:text;
    i,j:integer;
begin
 new(techniques,9,5);
 new(target,5);
 new(startingresource,5);
 new (L,5);
  new(X,9);
  new(R,5);
 target^:=ctarget;
 
 startingresource^:=cstartingresource;
 techniques^:=ctechniques;
 writeln('call kantorovich method');
 kantorovichMethod(techniques ^,  target^,startingresource^,L^ ,X^);
 (*! define valid if sum of squared errors relative to kantorovich is less than 1/10000 *)
 if ((\+ ((x^-kantorovichsanswer)*(x^-kantorovichsanswer)))/(\+ x^))<0.0001 then
 begin
  writeln('accuracy ok ');
  end
  else 
  begin
    writeln('accuracy poor');
    writeln(x^,kantorovichsanswer);
  end;
  {now try to change the target output }
  target^[0]:=18000;
  
 kantorovichMethod(techniques ^,  target^,startingresource^,L^ ,X^);
 writeln('resolving multipliers');writeln(L^);
 writeln('intensities ');writeln(x^);
 r^:=0;
 for i:=1 to 9 do
 r^:= r^ + techniques^[i,dest]*x^[i];
 writeln('gross output/target ');
 writeln(r^/target^);
end;
begin 
 main;  
end.

